- Main Page
- Related Pages
- Modules
- Namespaces
- Classes
- Files
- Directories
- Examples

- Class List
- Class Hierarchy
- Class Members

Public Slots | Signals | Public Member Functions | Protected Member Functions | Protected Attributes

# AttributeCurveEditor Class Reference

Search for all occurrences

## Detailed Description

An attribute widget for displaying and interacting with multiple curve editors.

See the CurveEditor class for more information about how the curve editor works. In addition to the basic functionality provided by the curve editor class, this widget allows for multiple curve editors to be linked together and updated by each other. It also has an additional option for "Snap" which allows the dragging of curve points along the grid lines of the curve editor. There is also a "Store" button which allows the user to store the curve in other Mudbox tools such as sculpt, falloff etc. Lastly, this widget includes an enlarge icon beside the curve editor which displays the same curve in a larger dialog and allows it to be resized to convenient editing.

Definition at line 491 of file widgets.h.

`#include <widgets.h>`

Inheritance diagram for AttributeCurveEditor:
[legend]

List of all members.

## Public Slots
void | OnChange (void)
| This method is called when the NURBSCurve in the curve editor changes.
void | Update (void)
| Updates the widget values from the attribute.
void | OnEnlarge (void)
| This method is is called when the user clicks on the enlarge icon on the widget.
void | StartUpdateCountdown (void)
| This method starts the timer on which the widget will calls its update method.
void | OnColorCorrectionClosing (void)
| This method sends out a signal which tells all the EnlargedCurveEditor widgets which are editing this widget's attribute to close.
## Signals
void | ParentEditorInColorCorrectionClosing (void)
| This signal causes all other EnlargedCurveEditor widgets editing this widget's attribute to close.
## Public Member Functions
| AttributeCurveEditor (QWidget *pParent, int iWidth, acurveptr *pAttribute, bool bSnapAndStore, bool bInAdjustColor=false)
| Constructor.
bool | EditorInAdjustColor () const
| Returns whether this widget is being used in the Adjust Color dialog.
void | ReplaceNurbsInEditor (NURBSCurve *pCurve)
| Call this in order to override the NURBSCurve being used in this widget with another one.
## Protected Member Functions
bool | eventFilter (QObject *pTarget, QEvent *pEvent)
## Protected Attributes
QPushButton * | m_pStoreF
CurveEditor * | m_pCurveEditor

## Constructor & Destructor Documentation

AttributeCurveEditor | ( | QWidget * | pParent,
|  | int | iWidth,
|  | acurveptr * | pAttribute,
|  | bool | bSnapAndStore,
|  | bool | bInAdjustColor = `false`
| ) |  |

Constructor.

Parameters:

  [in] | pParent | The parent widget which will hold this attribute widget.
  [in] | iWidth | The desired width of the widget.
  [in] | pAttribute | The attribute curve pointer which this widget is attached to.
  [in] | bSnapAndStore | True if the Snap and Store widgets should be displayed.
  [in] | bInAdjustColor | True if the attribute widget is being used in the Adjust Color Dialog.

## Member Function Documentation

bool eventFilter | ( | QObject * | pTarget,
|  | QEvent * | pEvent
| ) |  | `[protected, virtual]`

Search for all occurrences

Reimplemented from QObject.

bool EditorInAdjustColor | ( |  | ) | const `[inline]`

Search for all occurrences

Returns whether this widget is being used in the Adjust Color dialog.

Definition at line 511 of file widgets.h.

    { return m_bUsedInAdjustColor; };

void ReplaceNurbsInEditor | ( | NURBSCurve * | pCurve | ) | `[inline]`

Search for all occurrences

Call this in order to override the NURBSCurve being used in this widget with another one.

This is useful for cases such as buttons which can reset the NURBSCurve currently used in the widget. You must call the NurbsValueChanged function on the CurveEditor used in this widget afterwards. For example, this would be a typical call sequence, where pA is a pointer to an AttributeCurveEditor: NURBSCurve *p = new NURBSCurve(3); pACE->ReplaceNurbsInEditor(p); CurveEditor* pCurveEditor = static_cast<CurveEditor*>(pAW->findChild<QFrame *>); pCurveEditor->NurbsValueChanged();

Definition at line 521 of file widgets.h.

    { m_pCurveEditor->Init(pCurve); };

void OnChange | ( | void |  | ) | `[slot]`

Search for all occurrences

This method is called when the NURBSCurve in the curve editor changes.

void Update | ( | void |  | ) | `[virtual, slot]`

Search for all occurrences

Updates the widget values from the attribute.

Reimplemented from AttributeWidget.

void OnEnlarge | ( | void |  | ) | `[slot]`

Search for all occurrences

This method is is called when the user clicks on the enlarge icon on the widget.

void StartUpdateCountdown | ( | void |  | ) | `[slot]`

Search for all occurrences

This method starts the timer on which the widget will calls its update method.

void OnColorCorrectionClosing | ( | void |  | ) | `[slot]`

Search for all occurrences

This method sends out a signal which tells all the EnlargedCurveEditor widgets which are editing this widget's attribute to close.

This is only called when this widget is used in the AdjustColorDialog.

void ParentEditorInColorCorrectionClosing | ( | void |  | ) | `[signal]`

Search for all occurrences

This signal causes all other EnlargedCurveEditor widgets editing this widget's attribute to close.

## Member Data Documentation

QPushButton* m_pStoreF `[protected]`

Search for all occurrences

Definition at line 496 of file widgets.h.

CurveEditor* m_pCurveEditor `[protected]`

Search for all occurrences

Definition at line 497 of file widgets.h.

The documentation for this class was generated from the following file:

- Mudbox/widgets.h

AttributeCurveEditor AttributeCurveEditor AttributeCurveEditor AttributeCurveEditor AttributeCurveEditor AttributeCurveEditor AttributeCurveEditor AttributeCurveEditor AttributeCurveEditor AttributeCurveEditor
AttributeCurveEditor AttributeCurveEditor AttributeCurveEditor AttributeCurveEditor AttributeCurveEditor AttributeCurveEditor AttributeCurveEditor AttributeCurveEditor AttributeCurveEditor AttributeCurveEditor